using System.Net;
using Common;
using Microsoft.AspNetCore.Http;
using Microsoft.AspNetCore.Mvc;

namespace Router
{
    /// <summary>
    /// Web API 
    /// </summary>
    class API
    {
        /// <summary>
        /// Send some String
        /// </summary>
        /// <param name="address">IP V4/V6 address</param>
        /// <param name="port">Device UDP port</param>
        /// <param name="text">Text for send</param>
        /// <returns>Json: true or false</returns>
        public static async ValueTask<IResult> SendString(string address, int port, string text)
        {
            var endPoint = new IPEndPoint(IPAddress.Parse(address), port);
            var ret = await UDPClientPool.SendStringAsync(endPoint, [text]);
            if (ret) { return Results.Json(true); }
            else { return Results.Json(false); }
        }


        [HttpPost]
        public static async ValueTask<IResult> SendAddrPackage(
            string address,
            int port,
            // WebProtocol.BurstType burstType,
            // byte commandID,
            // bool isWrite,
            // byte burstLength,
            // UInt32 devAddress)
            WebProtocol.SendAddrPackOptions opts)
        {
            // WebProtocol.SendAddrPackOptions opts;
            // opts.burstType = burstType;
            // opts.commandID = commandID;
            // opts.isWrite = isWrite;
            // opts.burstLength = burstLength;
            // opts.address = devAddress;

            var endPoint = new IPEndPoint(IPAddress.Parse(address), port);
            var ret = await UDPClientPool.SendAddrPackAsync(endPoint, new WebProtocol.SendAddrPackage(opts));
            if (ret) { return Results.Json(true); }
            else { return Results.Json(false); }
        }

        public static async ValueTask<IResult> SendDataPackage(string address, int port, string data)
        {
            var endPoint = new IPEndPoint(IPAddress.Parse(address), port);
            var ret = await UDPClientPool.SendDataPackAsync(endPoint,
                new WebProtocol.SendDataPackage(NumberProcessor.StringToBytes(data).Value));
            if (ret) { return Results.Json(true); }
            else { return Results.Json(false); }
        }

        public static async ValueTask<IResult> GetDeviceIDCode(string address, int port)
        {


        }
    }
}
